using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Text;
using System.Windows.Forms;

namespace XSOC_Gui
{
    public partial class ConsoleForm : Form
    {
        public ConsoleForm()
        {
            InitializeComponent();
        }
        delegate void cwlineCallback(string str);

        public void ConsoleWriteLine(string str){

            if (TB.InvokeRequired)
            {
                cwlineCallback d = new cwlineCallback(ConsoleWriteLine);
                this.Invoke(d, new object[] { str });
            }
            else
            {
                TB.Text += str + "\r\n";
                TB.SelectAll();
                TB.ScrollToCaret();
                TB.DeselectAll();
            }
        }
    }
}