/* file01.cc: fie beolvasasa es feldolgozasa */
#include <string>
#include <iostream>
#include <iomanip>
#include <fstream>

using namespace std;

void int2hex (int be, char& up, char& lo){
	switch (be % 16){
		case 0 : lo = '0';break;
		case 1 : lo = '1';break;
		case 2 : lo = '2';break;
		case 3 : lo = '3';break;
		case 4 : lo = '4';break;
		case 5 : lo = '5';break;
		case 6 : lo = '6';break;
		case 7 : lo = '7';break;
		case 8 : lo = '8';break;
		case 9 : lo = '9';break;
		case 10 : lo = 'A';break;
		case 11 : lo = 'B';break;
		case 12 : lo = 'C';break;
		case 13 : lo = 'D';break;
		case 14 : lo = 'E';break;
		case 15 : lo = 'F';break;
	}
	
	switch (be / 16){
		case 0 : up = '0';break;
		case 1 : up = '1';break;
		case 2 : up = '2';break;
		case 3 : up = '3';break;
		case 4 : up = '4';break;
		case 5 : up = '5';break;
		case 6 : up = '6';break;
		case 7 : up = '7';break;
		case 8 : up = '8';break;
		case 9 : up = '9';break;
		case 10 : up = 'A';break;
		case 11 : up = 'B';break;
		case 12 : up = 'C';break;
		case 13 : up = 'D';break;
		case 14 : up = 'E';break;
		case 15 : up = 'F';break;
	}
}


int main(int argc, char* argv[])
{ 
    ifstream inf(argv[1]);
	ofstream outf(argv[2]);
	
	int length;
	
	string line_in;
	string line_out_msb;
	string line_out_lsb;
	
	string info = "//Program init ";
	string bram_msb = "defparam msb_bram.INIT_";
	string bram_lsb = "defparam lsb_bram.INIT_";
	
	string nulla = "0000000000000000000000000000000000000000000000000000000000000000";
	string tmp;
	string msb;
	string lsb;
	
	string bytes;
	
	string* lines;
	int out_lines= 0;
	int in_lines = 0;
	int j;

	
	char hex_up,hex_lo;

	if (!inf) // sikerult megnyitni?
	{
		cerr << "Nem tudtam megnyitni a fajlt!";
		cin.get();
		return -1;
	}
	
	// file hossza:
 	inf.seekg (0, ios::end);
	length = inf.tellg();
	inf.seekg (0, ios::beg);

  
	int fix = (length / (59*4))+1;	// 59 karakteres a beolvasott sor, 4 sor tesz ki egy bram sort
     
	lines = new (nothrow)string [fix * 2 + 3];  	// 2 bram-ot kell feltlteni, 3 sor az infoknak
	if (!lines){
		cerr << "Mem.foglalasi hiba!" << endl;
    	exit(1);
	}
	
	lines [0] = info + "MSB    " + argv[1] + "\n";
	lines [fix+1] = "\n\n//---------------------------------------------\n\n\n";
	lines [fix+2] = info + "LSB    " + argv[1] + "\n";
	
	msb = lsb = "";
	
				
	if (outf.is_open()){
		while(!getline(inf, line_in).eof()){
// BEOLVASS
//	cout << line_in << endl;
			in_lines++;
			
			
			for (int i=0;i < line_in.length()-10;i+=3){
				bytes = line_in.substr(i+10,2);
				if ( !(i % 6) )
					msb.insert(0,bytes); //[63-mj-1] = ch1;
				else 
					lsb.insert(0,bytes); //[63-mj-1] = ch1;

			} // for vge
// TROLS
			if (!(in_lines % 4)){ //4 beolvasott sor utn 
				out_lines++;
				
				int2hex(out_lines-1, hex_up, hex_lo);

				line_out_msb = bram_msb + hex_up + hex_lo + " = 256'h";
  				line_out_lsb = bram_lsb + hex_up + hex_lo + " = 256'h";
				tmp = nulla;
			
				lines[out_lines] = line_out_msb + tmp.replace (64-msb.length(),msb.length(),msb) + ";\n";
				tmp = nulla;
				lines[fix+2+out_lines] = line_out_lsb + tmp.replace (64-lsb.length(),lsb.length(),lsb) + ";\n";
				msb = lsb = "";

			}	// if (!(in_lines % 4)) vge
		}	// while vge
		if (in_lines % 4){ // nem pont 4 sort olvastunk be a vgn	
			out_lines++;
			int2hex(out_lines-1, hex_up, hex_lo);
			
			line_out_msb = bram_msb + hex_up + hex_lo + " = 256'h";
  			line_out_lsb = bram_lsb + hex_up + hex_lo + " = 256'h";
			tmp = nulla;
			
			lines[out_lines] = line_out_msb + tmp.replace (64-msb.length(),msb.length(),msb) + ";\n";
			tmp = nulla;
			lines[fix+2+out_lines] = line_out_lsb + tmp.replace (64-lsb.length(),lsb.length(),lsb) + ";\n";
		}

// KIRS FILE-BA
		for (int i=0; i < fix*2+3;i++){
			//cout << lines[i];
			outf << lines [i];
		}
				
		outf.close();
		inf.close();
	} // if (outf.is_open()){ vge
} //main vge

