;
; CRT0.s -- xr16 C runtime library startup
; Created by: Peter Czako
;
; This file must be assembled first, so that reset and interrupt receive
; the correct addresses:
; 0000 reset vector
; 0010 interrupt vector;
; 
; Info:
;
; - SP initialized to 0x0FFE
; - No Interrupts handled
;

global _main


align 16
reset:   
   lea sp,0x0ffe
   j _main

align 16
interrupt:
   reti

